//*********************************
//ģ:FAT16.c
//:2011-05-10
//:FAT16ļϵͳҪSDıļ
//:
//*********************************

//**********ͷļ***************
#include "config.h"
#include "uart.h"
#include "FAT16.h"
#include "sd.h"

//************ȫֱ*****************
UINT16 FirstDataSector;	// һַ
UINT16 BytesPerSector;	// ÿֽ
UINT16 FATsectors;	// FAT
UINT16 SectorsPerClust;	// ÿص
UINT16 FirstFATSector;	// FA1ַ
UINT16 FirstDirSector;	// Ŀ¼ַ
UINT16 RootDirSectors;	// Ŀ¼
UINT16 RootDirCount;	// Ŀ¼

//*********************************
struct FileInfoStruct FileInfo;//ڴļһЩϢ

//*********************************
//FAT16_Init
//FAT16ļϵͳʼҪڴSDȡ
//룺
//0x00-ʼɹ 0x01-ʼʧ
//ú 
//                SD_readsectorsector,buffer
//:ʹSDȸʽ
//     FAT16ʼSDĳʼ֮ǰӦȵsdĳʼ
//*********************************
UINT8 FAT16_Init(void)
{
	struct B_S512 *bs  = 0;
	struct bpb25 *bpb = 0;
	UINT16 hidsec;
	UINT8 buffer[512];
	for(hidsec=0;hidsec<0x1000;hidsec++)
	{
		if(SD_readsector(hidsec,buffer))return 1;
		if(buffer[0]==0xeb || buffer[0]==0xe9)break;
	}
	if(hidsec==0x1000)return 1; 
	bs = (struct B_S512 *)buffer;
	if(bs->bsJump[0]!=0xE9 && bs->bsJump[0]!=0xEB)return 1;
	bpb = (struct bpb25 *)bs->bsBPB;        
	BytesPerSector	= bpb->bpbBytesPerSec;//ÿֽ
	FATsectors	= bpb->bpbFATsecs;//FATռõ
	SectorsPerClust	= (UINT8)bpb->bpbSecPerClust;//ÿ
	FirstFATSector	= bpb->bpbResSectors+hidsec;//һFAT
	RootDirCount	= bpb->bpbRootDirEnts;//Ŀ¼
	RootDirSectors	= (RootDirCount*32)>>9;//Ŀ¼ռõ
	FirstDirSector	= FirstFATSector+bpb->bpbFATs*FATsectors;//һĿ¼
	FirstDataSector	= FirstDirSector+RootDirSectors;//һ        
	return 0;
}

//*********************************
//FAT16_LoadPartCluster
//һеһ
//룺cluster-غ part-ƫƵַ buffer-
//0x00-ɹ 0x01-ʧ
//ú 
//                SD_readsectorsector,buffer
//
//*********************************
UINT8 FAT16_LoadPartCluster(UINT16 cluster,UINT16 part,UINT8 * buffer)
{
	UINT32 sector;
	sector=FirstDataSector+(UINT32)(cluster-2)*(UINT32)SectorsPerClust;//ʵ
	if(SD_readsector(sector+part,buffer))return 1;
	else return 0;
}

//*********************************
//FAT16_LoadCluster
//
//룺cluster-غ buffer-
//0x00-ɹ 0x01-ʧ
//õ 
//                SD_readsectorsector,buffer
//
//*********************************
UINT8 FAT16_LoadCluster(UINT16 cluster,UINT8 * buffer)
{
	UINT32 sector;
	UINT8 i;
	sector=FirstDataSector+(UINT32)(cluster-2)*(UINT32)SectorsPerClust;
	for(i=0;i<SectorsPerClust;i++)
	{
		if(SD_readsector(sector+i,buffer+(i<<9)))break;
	}
	if(i==SectorsPerClust)return 0;
	else return 1;
}

//*********************************
//FAT16_NextCluster
//:һشغ
//룺cluster-غ
//һصĴغ
//ú 
//                SD_readsectorsector,buffer
//
//*********************************
UINT16 FAT16_NextCluster(UINT16 cluster)
{
	UINT8 buffer[512];
	UINT32 sector;
	UINT32 offset=cluster/256;
	if(cluster<2)return 0xfff8;
	sector=FirstFATSector+offset;//ʵ
	if(SD_readsector(sector,buffer))return 0xfff8;
	offset=cluster%256;
	sector=((UINT16 *)buffer)[offset];
	return ((UINT16)sector);
}

//*********************************
//FAT16_FindFreeCluster
//:FATڲҿմ
//룺
//cnt-մغ 0x01-ʧ
//ú 
//                SD_readsectorsector,buffer
//
//*********************************
UINT16 FAT16_FindFreeCluster(void)
{
	UINT8 buffer[512];
	UINT16 i;
	UINT16 cnt;

	for(cnt=0;cnt<FATsectors;cnt++)//find in the FAT table
	{
		if(SD_readsector(FirstFATSector+cnt,buffer))return 1;
		for(i=0;i<256;i++)
		{
			if(((UINT16 *)buffer)[i]==0x0000)break;//δʹô
		}
		if(i!=256)
		{
			cnt=cnt*512+i;
			return cnt;//ؿеĴغ                 
		}
	}
	return 1;
}

//*********************************
//FAT16_FindFreeItem
//:clusterָĿ¼һλü¼ļ
//룺cluster-غ FileInfo-ļ
//0x00-ҳɹ 0x01-ʧ
//ú 
//                SD_readsectorsector,buffer
//                FAT16_NextCluster(tempclust)
//
//*********************************
UINT16 FAT16_FindFreeItem(UINT16 cluster, struct FileInfoStruct *FileInfo)
{
	UINT8 *buffer;
	UINT32 tempclust;
	UINT32 sector;
	UINT8 cnt;
	UINT16 offset;
	struct direntry *item = 0;
	if(cluster==0)//Ŀ¼
	{
		buffer=malloc(512);//512ֽڴռ
		if(buffer==0)return 1;
		for(cnt=0;cnt<RootDirSectors;cnt++)
		{
			if(SD_readsector(FirstDirSector+cnt,buffer)){free(buffer);return 1;}//
			for(offset=0;offset<512;offset+=32)
			{
				item=(struct direntry *)(&buffer[offset]);
				if((item->deName[0] != 0x00) & (item->deName[0] != 0xe5) & (item->deAttributes != 0x0f));
				else
				{

					FileInfo->StartCluster = item->deStartCluster;
					FileInfo->Size         = item->deFileSize;
					FileInfo->Attr         = item->deAttributes;
					FileInfo->Sector       = FirstDirSector+cnt;
					FileInfo->Offset       = offset;
					free(buffer);
					return 0;
				}
			}
		}
		free(buffer);//ͷڴռ
	}
	else  //һĿ¼ʱûǵĿ¼ûпҪһ¼
	{
		tempclust=cluster;
		while(1)
		{
			sector=FirstDataSector+(tempclust-2)*SectorsPerClust;//ʵ
			buffer=malloc(512);//512ֽڴռ
			if(buffer==0)return 1;
			for(cnt=0;cnt<SectorsPerClust;cnt++)
			{
				if(SD_readsector(sector+cnt,buffer)){free(buffer);return 1;}
				for(offset=0;offset<512;offset+=32)
				{
					item=(struct direntry *)(&buffer[offset]);
					if((item->deName[0] != 0x2e) & (item->deName[0] != 0x00) & (item->deName[0] != 0xe5) & (item->deAttributes != 0x0f));
					else
					{
						FileInfo->StartCluster = item->deStartCluster;
						FileInfo->Size         = item->deFileSize;
						FileInfo->Attr         = item->deAttributes;
						FileInfo->Sector       = sector+cnt;
						FileInfo->Offset       = offset;
						free(buffer);
						return 0;
					}
				}
			}
			free(buffer);//ͷڿռ
			tempclust=FAT16_NextCluster(tempclust);//һ
			if(tempclust == 0xffff || tempclust == 0xfff8)return 1;
		}
	}
	return 1;
}



//*********************************
//FAT16_FindItem
//:ڸĿ¼²ļ
//룺cluster-غ *name-ļ *FileInfo-ļ
//ʼغ  0x01-ʧ
//ú 
//               SD_readsectorsector,buffer
//
//*********************************
UINT16 FAT16_FindItem(UINT16 cluster, UINT8 *name, struct FileInfoStruct *FileInfo)
{
	UINT8 *buffer;
	UINT32 tempclust;
	UINT32 sector;
	UINT8 cnt;
	UINT16 offset;
	UINT8 i;
	struct direntry *item = 0;
	if(cluster==0)// cluster==0,ζŸĿ¼
	{
		buffer=malloc(512);//512ֽڴռ
		if(buffer==0)return 1;
		for(cnt=0;cnt<RootDirSectors;cnt++)
		{
			if(SD_readsector(FirstDirSector+cnt,buffer)){free(buffer);return 1;}//ȡɹȡʧͷڴռ䲢
			for(offset=0;offset<512;offset+=32)
			{
				item=(struct direntry *)(&buffer[offset]);
				if((item->deName[0] != 0x00) & (item->deName[0] != 0xe5) & (item->deAttributes != 0x0f))
				{
					for(i=0;i<11;i++)
					{
						if(buffer[offset+i]!=name[i])break;
					}
					if(i==11)
					{
						//return the parameter of the item
						FileInfo->StartCluster = item->deStartCluster;
						FileInfo->Size         = item->deFileSize;
						FileInfo->Attr         = item->deAttributes;
						FileInfo->Sector       = FirstDirSector+cnt;
						FileInfo->Offset       = offset;
						free(buffer);
						return 0;
					}
				}
			}
		}
		free(buffer);//ͷڴռ
	}
	else//ļ
	{
		tempclust=cluster;
		while(1)
		{
			sector=FirstDataSector+(UINT32)(tempclust-2)*(UINT32)SectorsPerClust;//ʵ
			buffer=malloc(512);//512ֽڴռ
			if(buffer==0)return 1;
			for(cnt=0;cnt<SectorsPerClust;cnt++)
			{
				if(SD_readsector(sector+cnt,buffer)){free(buffer);return 1;}
				for(offset=0;offset<512;offset+=32)
				{
					item=(struct direntry *)(&buffer[offset]);
					if((item->deName[0] != 0x00) & (item->deName[0] != 0xe5) & (item->deAttributes != 0x0f))
					{
						for(i=0;i<11;i++)
						{
							if(buffer[offset+i]!=name[i])break;
						}
						if(i==11)
						{
							FileInfo->StartCluster = item->deStartCluster;
							FileInfo->Size         = item->deFileSize;
							FileInfo->Attr         = item->deAttributes;
							FileInfo->Sector       = sector+cnt;
							FileInfo->Offset       = offset;
							free(buffer);
							return 0;
						}
					}
				}
			}
			free(buffer);  //ͷڴռ
			tempclust=FAT16_NextCluster(tempclust);//һ
			if(tempclust == 0xffff || tempclust == 0xfff8)break;
		}
	}
	return 1;
}

//*********************************
//FAT16_SelectOneItem
//:ѡһδʹõļ
//룺cluster-غ *FileInfo-ļ
//0x00-ɾɹ  0x01-ɾʧ
//ú 
//               SD_readsectorsector,buffer
//               FAT16_NextCluster(tempclust)
//Ҫɾļ
//*********************************
UINT8 FAT16_SelectOneItem(UINT16 cluster,struct FileInfoStruct *FileInfo)
{
	UINT8 *buffer;
	UINT32 tempclust;
	UINT32 sector;
	UINT8 cnt;
	UINT16 offset;
	struct direntry *item = 0;
	if(cluster==0)//Ŀ¼
	{
		buffer=malloc(512);
		if(buffer==0)return 1;
		for(cnt=0;cnt<RootDirSectors;cnt++)
		{
			if(SD_readsector(FirstDirSector+cnt,buffer)){free(buffer);return 1;}
			for(offset=0;offset<512;offset+=32)
			{
				item=(struct direntry *)(&buffer[offset]);
				if((item->deName[0] != 0x00) & (item->deName[0] != 0xe5) & (item->deAttributes != 0x0f))
				{
					FileInfo->StartCluster = item->deStartCluster;
					FileInfo->Size         = item->deFileSize;
					FileInfo->Attr         = item->deAttributes;
					FileInfo->Sector       = FirstDirSector+cnt;
					FileInfo->Offset       = offset;
					free(buffer);
					return 0;
				}
			}
		}
		free(buffer);
	}
	else//ļĿ¼
	{
		tempclust=cluster;
		while(1)
		{
			sector=FirstDataSector+(UINT32)(tempclust-2)*(UINT32)SectorsPerClust;//ʵ
			buffer=malloc(512);//512ֽڴռ
			if(buffer==0)return 1;
			for(cnt=0;cnt<SectorsPerClust;cnt++)
			{
				if(SD_readsector(sector+cnt,buffer)){free(buffer);return 1;}
				for(offset=0;offset<512;offset+=32)
				{
					item=(struct direntry *)(&buffer[offset]);
					if((item->deName[0] != 0x2e) & (item->deName[0] != 0x00) & (item->deName[0] != 0xe5) & (item->deAttributes != 0x0f))
					{
						FileInfo->StartCluster = item->deStartCluster;
						FileInfo->Size         = item->deFileSize;
						FileInfo->Attr         = item->deAttributes;
						FileInfo->Sector       = sector+cnt;
						FileInfo->Offset       = offset;
						free(buffer);
						return 0;
					}
				}
			}
			free(buffer);
			tempclust=FAT16_NextCluster(tempclust);//ҳһغ
			if(tempclust == 0xffff || tempclust == 0xfff8)break;
		}
	}
	return 1;
}
//*********************************
//FAT16_ModifyFAT
//:޸FATӦ
//룺cluster-غ val-Ӧ
//0x00-޸ĳɹ 0x01-޸ʧ
//ú 
//               SD_readsectorsector,buffer
//               SD_writesector(sector,buffer)
//*********************************
UINT8 FAT16_ModifyFAT(UINT16 cluster,UINT16 val)
{
	UINT8 buffer[512];
	UINT32 sector;
	UINT32 offset=cluster/256;

	sector=FirstFATSector+offset;//ʵ
	if(SD_readsector(sector,buffer))return 1;//FAT

	offset=cluster%256;
	offset<<=1;
	buffer[offset+1] = val>>8;
	buffer[offset]   = val;
	if(SD_writesector(sector,buffer))return 1;//дFAT1
	if(SD_writesector(sector+FATsectors,buffer))return 1;//дFAT2
	return 0;
}




//*********************************
//FAT16_Create
//:ļ
//룺*dir-Ŀַ size-С
//cluster-ļʼ 0x01-ʧ
//ú 
//               SD_readsectorsector,buffer
//               SD_writesector(sector,buffer)
//               FAT16_FindItem(cluster,name, &FileInfo)
//ļ֪С
//*********************************
UINT16 FAT16_Create(UINT8 * dir,UINT32 size)
{
	UINT8 name[11];
	UINT8 *p=dir;
	UINT8 deep=0;
	UINT8 i,j;
	UINT32 cluster=0;
	UINT8 *buffer;
	struct direntry *item;
	if(*p != '\\')return 1;//Чַ򷵻ء "\\"ǰһ"\"תַı־
	while(*p)
	{
		if(*p == '\\')
		{
			deep++;
		}
		p++;
	}
	p=dir;
	for(i=0;i<deep-1;i++)
	{
		p++;
		for(j=0;j<11;j++)name[j]=0x20;
		j=0;
		while(*p != '\\')
		{
			if((*p) >= 'a' && (*p) <= 'z')name[j] = (*p++)-0x20;
			else name[j] = *p++;
			j++;
		}
		if(FAT16_FindItem(cluster,name, &FileInfo))return 1; //ڸĿ¼²ļ
		cluster = FileInfo.StartCluster;
	}
	p++;
	for(j=0;j<11;j++)name[j]=0x20;
	j=0;
	while(*p != '.')
	{
		if(*p>='a' && *p<='z')name[j]=(*p++)-0x20;
		else name[j]=*p++;
		j++;
	}
	j=8;
	p++;
	while(*p)
	{
		if(*p>='a' && *p<='z')name[j]=(*p++)-0x20;
		else name[j]=*p++;
		j++;
	}


	if(FAT16_FindFreeItem(cluster,&FileInfo))return 1;//clusterָĿ¼һλü¼ļ
	cluster = FAT16_FindFreeCluster();//FATҿմ
	if(cluster==1)return 1;
	buffer=malloc(512);
	if(buffer==0)return 1;
	if(SD_readsector(FileInfo.Sector,buffer)){free(buffer);return 1;}
	item=(struct direntry *)(&buffer[FileInfo.Offset]);

	for(j=0;j<8;j++)item->deName[j] = name[j]; //ļ,8λ
	for(j=0;j<3;j++)item->deExtension[j] = name[8+j]; //ļչ,3λ
	item->deAttributes = Attribute_ARCHIVE;//file
	item->deLowerCase = LowerCase_BASE | LowerCase_EXT;
	item->deCHundredth = 0;
	item->deCTime[0] = 0;
	item->deCTime[1] = 0;
	item->deCDate[0] = 0;
	item->deCDate[1] = 0;
	item->deADate[0] = 0;
	item->deADate[1] = 0;
	item->deHighClust = 0;
	item->deMTime[0] = 0;
	item->deMTime[1] = 0;
	item->deMDate[0] = 0;
	item->deMDate[1] = 0;
	item->deStartCluster = cluster;//ļʼ
	item->deFileSize = size;//ļС
	if(SD_writesector(FileInfo.Sector,buffer)){free(buffer);return 1;}
	free(buffer);
	if(FAT16_ModifyFAT(cluster,0xffff))return 1;//޸FATӦ
	return cluster;//ļʼ
}

//*********************************
//FAT16_Open
//:֪·ļ
//룺*dir-Ŀַ
//cluster-ļʼ 0x01-ʧ
//ú 
//               SD_readsectorsector,buffer
//               FAT16_FindItem(cluster,name, &FileInfo)
//򿪵ļ·֪
//*********************************
UINT16 FAT16_Open(UINT8 * dir)
{
	UINT8 name[11];
	UINT8 *p=dir;
	UINT8 deep=0;
	UINT8 i,j;
	UINT32 cluster=0;
	if(*p != '\\')return 1;
	while(*p)
	{
		if(*p == '\\')
		{
			deep++;
		}
		p++;
	}
	p=dir;
	for(i=0;i<deep-1;i++)
	{
		p++;
		for(j=0;j<11;j++)name[j]=0x20;
		j=0;
		while(*p != '\\')
		{
			if((*p) >= 'a' && (*p) <= 'z')name[j] = (*p++)-0x20;
			else name[j] = *p++;
			j++;
		}
		if(FAT16_FindItem(cluster,name, &FileInfo))return 1;//ڸĿ¼²ļ
		cluster = FileInfo.StartCluster;
	}
	p++;
	for(j=0;j<11;j++)name[j]=0x20;
	j=0;
	while(*p != '.')  //ļһչ
	{
		if(*p>='a' && *p<='z')name[j]=(*p++)-0x20; //СдתΪд a=0x61 A=0x41
		else name[j]=*p++;
		j++;
	}
	j=8;
	p++;
	while(*p)
	{
		if(*p>='a' && *p<='z')name[j]=(*p++)-0x20;
		else name[j]=*p++;
		j++;
	}
	if(FAT16_FindItem(cluster,name, &FileInfo))return 1;//ڸĿ¼²ļ
	cluster = FileInfo.StartCluster;
	return cluster;
}

//*********************************
//FAT16_Read
//:֪ʼضȡļ
//룺pointer-ļʼ size-ļС
//0x00-ȡɹ 0x01-ȡʧ
//ú 
//               SD_readsectorsector,buffer
//               FAT16_FindItem(cluster,name, &FileInfo)
//               FAT16_NextCluster(tempclust)
//size ==0 ,ζȡļ
//*********************************
UINT8 FAT16_Read(UINT16 pointer, UINT32 size)
{
	UINT32 sector;
	UINT32 tempclust=pointer;
	UINT8 *buffer;
	UINT16 i=0,j=0;
	sector=FirstDataSector+(UINT32)(tempclust-2)*(UINT32)SectorsPerClust;
	if(size==0)size = FileInfo.Size;
	while(size)
	{
		buffer=malloc(512);
		if(SD_readsector(sector+j,buffer)){free(buffer);return 1;}
		if(size<=512)
		{
			for(i=0;i<size;i++)
			{
                              UART0_PutChar(buffer[i]);//ӡȡÿַ
			}
			free(buffer);
			return 0;
		}
		else
		{
			for(i=0;i<512;i++)
			{
				UART0_PutChar(buffer[i]);
			}
			j++;
			if(j==SectorsPerClust)
			{
				j=0;
				free(buffer);
				tempclust=FAT16_NextCluster(tempclust);//һ
				if(tempclust==0xffff || tempclust==0xfff8)return 1;
				sector=FirstDataSector+(UINT32)(tempclust-2)*(UINT32)SectorsPerClust;
			}
			else free(buffer);
			size-=512;
			
		}
	}
	return 0;
}

//*********************************
//FAT16_Write
//:֪ʼдļ
//룺cluster-ļʼ *data- size-ļС
//0x00-дɹ 0x01-дʧ
//ú 
//             SD_writesector(sector,buffer)
//СΪ512ֽ
//*********************************
UINT8 FAT16_Write(UINT16 cluster,UINT8 *data,UINT32 size)
{
	UINT8 buffer[512];
	UINT32 sector;
	UINT16 i;
	for(i=0;i<size;i++)
	{
		buffer[i]=data[i];
	}
	sector=FirstDataSector+(UINT32)(cluster-2)*(UINT32)SectorsPerClust;
	if(SD_writesector(sector,buffer))return 1;//д
	return 0;
}

//*********************************
//FAT16_Delete
//:ַ֪ɾļ
//룺*dir-Ŀַ
//0x00-ɾɹ 0x01-ɾʧ
//ú 
//             FAT16_Open(dir)
//             FAT16_DelItem(&FileInfo))
//
//*********************************
UINT8 FAT16_Delete(UINT8 *dir)
{
	if(FAT16_Open(dir)==0)return 1;//ļ
	if(FAT16_DelItem(&FileInfo))return 1;//ɾļ
	return 0;
}

//*********************************
//FAT16_DelItem
//:ɾļ
//룺*FileInfo-ļ
//0x00-ɾɹ 0x01-ɾʧ
//ú 
//             SD_readsector(sector,buffer)
//             SD_writesector(sector,buffer)
//             FAT16_SelectOneItem(cluster,FileInfo)
//             FAT16_DelItem(FileInfo)
//             FAT16_ModifyFAT(cluster,0)
//             FAT16_NextCluster(cluster)
//             FAT16_Open(dir)
//             FAT16_DelItem(&FileInfo))
//
//*********************************
UINT8 FAT16_DelItem(struct FileInfoStruct *FileInfo)
{
	UINT8 *buffer;
	struct direntry *item;
	UINT16 cluster;
	UINT16 tempclust;
	buffer=malloc(512);
	if(buffer==0)return 1;
	if(SD_readsector(FileInfo->Sector,buffer)){free(buffer);return 1;}
	item=(struct direntry *)(&buffer[FileInfo->Offset]);
	item->deName[0]=0xe5;//0xe5deName[0],ļѾɾ
	if(SD_writesector(FileInfo->Sector,buffer)){free(buffer);return 1;}
	free(buffer);
	cluster=FileInfo->StartCluster;
	if(FileInfo->Attr & 0x10)//if the item is a folder
	{
		while(1)
		{
			while(FAT16_SelectOneItem(cluster,FileInfo)==0)
			{
				if(FAT16_DelItem(FileInfo))return 1;
			}
			tempclust=FAT16_NextCluster(cluster);
			if(tempclust==1)return 1;
			if(FAT16_ModifyFAT(cluster,0))return 1;//ӦFATʹü¼
			cluster=tempclust;
			if(cluster == 0xfff8)return 1;
			if(cluster == 0xffff)break;
		}
	}
	else
	{ 
		while(1)
		{
			tempclust=FAT16_NextCluster(cluster);
			if(tempclust==1)return 1;
			if(FAT16_ModifyFAT(cluster,0))return 1;//ɾǰ
			cluster=tempclust;
			if(cluster == 0xfff8)return 1;
			if(cluster == 0xffff)break;//ļβ
		}
		if(FAT16_ModifyFAT(cluster,0))return 1;//ɾһ
	}
	return 0;
}

//*********************************
//FAT16_Rename
//:ļ
//룺*dir-Ŀļַ *newname-ļ
//0x00-ɹ 0x01-ʧ
//ú 
//           FAT16_FindItem(cluster,name, &FileInfo)
//           SD_readsector(sector,buffer)
//           SD_writesector(sector,buffer)        
//*newnameʵһµ·"\\123.txt"
//*********************************
UINT8 FAT16_Rename(UINT8 *dir,UINT8 *newname)
{
	UINT8 name[11];
	UINT8 *p=dir;
	UINT8 deep=0;
	UINT8 i,j;
	UINT32 cluster=0;
	UINT8 *buffer;
	struct direntry *item;
	if(*p != '\\')return 1;
	while(*p)
	{
		if(*p == '\\')
		{
			deep++;
		}
		p++;
	}
	p=dir;
	for(i=0;i<deep-1;i++)
	{
		p++;
		for(j=0;j<11;j++)name[j]=0x20;
		j=0;
		while(*p != '\\')
		{
			if((*p) >= 'a' && (*p) <= 'z')name[j] = (*p++)-0x20;
			else name[j] = *p++;
			j++;
		}
		if(FAT16_FindItem(cluster,name, &FileInfo))return 1;
		cluster = FileInfo.StartCluster;
	}
	p++;
	for(j=0;j<11;j++)name[j]=0x20;
	j=0;
	while((*p != '.') && (*p) )
	{
		if(*p>='a' && *p<='z')name[j]=(*p++)-0x20;
		else name[j]=*p++;
		j++;
	}
	j=8;
	if(*p == '.')//if it is a file
	{
		p++;
		while(*p)
		{
			if(*p>='a' && *p<='z')name[j]=(*p++)-0x20;
			else name[j]=*p++;
			j++;
		}
	}
	if(FAT16_FindItem(cluster,name, &FileInfo))return 1;//ļϢ
	buffer=malloc(512);
	if(buffer==0)return 1;
	if(SD_readsector(FileInfo.Sector,buffer)){free(buffer);return 1;}
	item=(struct direntry *)(&buffer[FileInfo.Offset]);
	p=newname;
	for(j=0;j<11;j++)item->deName[j]=0x20;
	j=0;
	while((*p != '.') && (*p))
	{
		if(*p>='a' && *p<='z')item->deName[j]=(*p++)-0x20;
		else item->deName[j]=*p++;
		j++;
	}
	j=8;
	if(*p == '.')
	{
		p++;
		while(*p)
		{
			if(*p>='a' && *p<='z')item->deName[j]=(*p++)-0x20;
			else item->deName[j]=*p++;
			j++;
		}
	}
	if(SD_writesector(FileInfo.Sector,buffer)){free(buffer);return 1;}
	free(buffer);
	return 0;
}
