#ifndef __FAT16_H__
#define __FAT16_H__

#include <stdlib.h>
#include "uart.h"
#include "config.h"
#include "sd.h"

#pragma pack(push) //״̬
#pragma pack(1)    //趨Ϊ1ֽڶ
struct B_S512 //512ֽ
{
	UINT8	bsJump[3];					
	UINT8	bsOemName[8];
	UINT8	bsBPB[25];
	UINT8	bsExt[26];
	UINT8	bsBootCode[448];
	UINT8	bsBootSectSig0;
	UINT8	bsBootSectSig1;
#define BOOTSIG0        0x55
#define BOOTSIG1        0xaa
};


struct bpb25
{
        UINT16	bpbBytesPerSec; // ÿֽ
        UINT8	bpbSecPerClust; // ÿ
        UINT16	bpbResSectors;  // 
        UINT8	bpbFATs;        // FATļ
        UINT16	bpbRootDirEnts; // Ŀ¼
        UINT16	bpbSectors;     // SD
        UINT8	bpbMedia;       // 
        UINT16	bpbFATsecs;     // ÿFAT
        UINT16	bpbSecPerTrack; // ÿŵ
        UINT16	bpbHeads;       // ͷ
        UINT32	bpbHiddenSecs;  // 
        UINT32	bpbHugeSectors; 
};

struct direntry {
		UINT8		deName[8]; //ļ
		UINT8		deExtension[3]; //ļչ
		UINT8		deAttributes;//ļ
#define Attribute_NORMAL     0x00            //
#define Attribute_READONLY   0x01            //ֻ
#define Attribute_HIDDEN     0x02            //
#define Attribute_SYSTEM     0x04            //ϵͳļ
#define Attribute_LABEL      0x80            //
#define Attribute_DIRECTORY  0x10            //Ŀ¼               
#define Attribute_LONG_FILENAME	0x0F	     //ļ
#define Attribute_ARCHIVE    0x20            //ļ´޸
         	UINT8        deLowerCase;    //ϵͳ
#define LowerCase_BASE      0x08            //ļСд
#define LowerCase_EXT       0x10            //ļչСд
		UINT8        deCHundredth;
		UINT8        deCTime[2];
		UINT8        deCDate[2];
		UINT8        deADate[2];
		UINT16       deHighClust;
		UINT8        deMTime[2];
		UINT8        deMDate[2];
		UINT16       deStartCluster;
		UINT32       deFileSize;
};

struct FileInfoStruct
{
	UINT16 StartCluster;	//ļʼ
	UINT32 Size;		//ļС
	UINT8  Attr;		//ļ 
	UINT16 Sector;		//ļ
	UINT16 Offset;		//ļƫƵַ
};
#pragma pack(pop)//ָ״̬
//*********************************
UINT8 FAT16_Init(void);//ļϵͳʼ
UINT8 FAT16_LoadCluster(UINT16 cluster,UINT8 * buffer);//һ
UINT16 FAT16_NextCluster(UINT16 cluster);//һغ
UINT16 FAT16_FindFreeCluster(void);//ҿմ
UINT16 FAT16_FindItem(UINT16 cluster, UINT8 *name, struct FileInfoStruct *FileInfo);//ļ,1ʾûҵļ
UINT16 FAT16_Open(UINT8 * dir);//ļ
UINT8 FAT16_Read(UINT16 pointer, UINT32 size);//ļsize=0ļ
UINT8 FAT16_Rename(UINT8 *dir,UINT8 *newname);//
UINT8 FAT16_ModifyFAT(UINT16 cluster,UINT16 val);//޸FAT
UINT8 FAT16_Delete(UINT8 *dir);//ɾļ
UINT8 FAT16_DelItem(struct FileInfoStruct *FileInfo);//ɾ¼
UINT16 FAT16_FindFreeItem(UINT16 cluster, struct FileInfoStruct *FileInfo);//ҿ
UINT8 FAT16_Write(UINT16 cluster,UINT8 *data,UINT32 size);//дļ
UINT16 FAT16_Create(UINT8 * dir,UINT32 size);//ļָļС
#endif
